{-# LANGUAGE OverloadedStrings #-}

module HAL where

import Data.Default (def)
import Data.Text

import Network.HTTP.Client (newManager)
import Network.HTTP.Client.TLS (tlsManagerSettings)

import Servant.Client (BaseUrl(..), Scheme(..), ClientM, ClientError, runClientM, mkClientEnv)

import HAL.Client
import HAL.Doc

runHalAPIClient :: ClientM (Response Doc) -> IO (Either ClientError (Response Doc))
runHalAPIClient cmd = do
  manager' <- newManager tlsManagerSettings
  runClientM cmd (mkClientEnv manager' $ BaseUrl Https "api.archives-ouvertes.fr" 443 "")

runStructureRequest :: Maybe Text -> IO (Either ClientError (Response Doc))
runStructureRequest rq =
  runHalAPIClient $ structure def rq (Just 10000)

runSearchRequest :: [Text] -> IO (Either ClientError (Response Doc))
runSearchRequest rq =
  runHalAPIClient $ search def rq Nothing Nothing Nothing
